<?php
/**
 * Created by PhpStorm.
 * User: heyu
 * Date: 2019-07-18
 * Time: 19:48
 */

namespace kwy\tp5util\apiuser\lib;


class Md5Sign
{

    private $last_true_sign='';

    private $last_presign_str='';

    public function getSign($params,$key){
        if (isset($params['sign'])){
            $orig_sign=$params['sign'];
            unset($params['sign']);
        }
        $str='';
        ksort($params);
        foreach ($params as $k=>$v){
            $str.=$k.'='.$v.'&';
        }
        $str.='key='.$key;
        $this->last_presign_str=$str;
        $this->last_true_sign=$sign=strtoupper(md5($str));
        return $sign;
    }

    public function getNonceStr($len=32){
        $chars='abcdefghijklmnopqrstuvwxyz1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $nonceStr='';
        $chars_len=strlen($chars);
        for ($i=0;$i<$len;$i++){
            $nonceStr.=$chars{rand(0,$chars_len-1)};
        }
        return $nonceStr;
    }

    /**
     * @param $params
     * @param $key
     * @throws \Exception
     */
    public function verifySign($params,$key){
        if (!isset($params['sign'])){
            throw new \Exception('签名不存在');
        }
        $orig_sign=$params['sign'];
        unset($params['sign']);
        if (strcmp($this->getSign($params,$key),$orig_sign)!==0){
            throw new \Exception('签名错误');
        }
    }

    /**
     * @return string
     */
    public function getLastPresignStr(): string
    {
        return $this->last_presign_str;
    }

    public function getLastTrueSign(){
        return $this->last_true_sign;
    }
}