<?php
/**
 *
 * Auther: heyu
 * DateTime: 2019-08-23 10:10
 *
 */

namespace kwy\tp5util\apiuser\model;


use think\Model;

/**
 * Class ApiAuth
 * @property int $id
 * @property string $appid
 * @property string $api
 * @property string $create_time
 */
class ApiAuth extends Model
{
    protected $connection='api_user';

    protected $table='api_auth';

    /**
     * 是否含有权限
     * @param string $appid
     * @param string $api
     * @return bool
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\ModelNotFoundException
     * @throws \think\exception\DbException
     */
    public function hasAuth($appid,$api){
        $self = $this->where('appid','=',$appid)
            ->where('api','=',$api)
            ->cache(true,300)
            ->find();
        if (empty($self)){
            return false;
        }else{
            return true;
        }
    }

}